/**
 * Swagger bookshelf
 * TODO
 *
 * OpenAPI spec version: 1.0.0
 * Contact: gestin.gweltaz@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import {Editor} from './editor';
import {BookSeries} from './series';
import {RestEntity} from './rest-entity';
import {Contract} from './contract';
import {BookMetadata} from "./book-metadata";

export interface Book extends RestEntity {
  arkId?: string;
  contracts: Contract[];
  collection?: string;
  /**
   * The filename of the cover file (random string)
   */
  cover?: string;
  editor: Editor;
  isbn?: string;
  series: BookSeries | null;
  /**
   * The current reading status
   */
  status: Book.StatusEnum;
  title: string;
  year?: string;
  possessionStatus?: string;
  metadata: BookMetadata
  lent: boolean
}

export type BookStatus = keyof typeof Book.StatusEnum;
export type BookPossessionStatus = keyof typeof Book.PossessionStatusEnum;

/**
 * @deprecated
 * @todo change to library instead of book
 */
export namespace Book {
  export type StatusEnum = 'READ' | 'UNREAD' | 'READING';
  export const StatusEnum = {
    READ: 'READ' as StatusEnum,
    UNREAD: 'UNREAD' as StatusEnum,
    READING: 'READING' as StatusEnum
  };

  export namespace BookStatus {
    export function values(): BookStatus[] {
      return Object.keys(Book.StatusEnum).filter((v: string | number) => typeof v == 'string' && isNaN(Number(v))) as BookStatus[]
    }
  }

  export type PossessionStatusEnum = 'NOT_POSSESSED' | 'POSSESSED';
  export const PossessionStatusEnum = {
    NOT_POSSESSED: 'NOT_POSSESSED' as PossessionStatusEnum,
    POSSESSED: 'POSSESSED' as PossessionStatusEnum
  };

  export namespace BookPossessionStatus {
    export function values(): BookPossessionStatus[] {
      return Object.keys(Book.PossessionStatusEnum).filter((v: string | number) => typeof v == 'string' && isNaN(Number(v))) as BookPossessionStatus[]
    }
  }
}
